$.fn.listHandlers = function (events, outputFunction) {
  'use strict';
  return this.each(function () {
    var elem = this, dEvents = $(this).data('events');
    if (!dEvents) {
      return;
    }
    $.each(dEvents, function (name, handler) {
      if ((new RegExp('^(' + (events === '*' ? '.+' : events.replace(',', '|').replace(/^on/i, '')) + ')$', 'i')).test(name)) {
        $.each(handler, function (i, handler) {
          outputFunction(elem, '\n' + i + ': [' + name + '] : ' + handler);
        });
      }
    });
  });
};

// parseJSON wasn't added to jquery until version 1.4.1 but is required by this
// module.  See https://github.com/jquery/jquery/blob/1.4.1/src/core.js#L474-493
$.extend({
  parseJSON: (typeof $.parseJSON !== 'undefined') ? $.parseJSON : function (data) {
    if (typeof data !== "string" || !data) {
      return null;
    }
    data = jQuery.trim(data);
    if (/^[\],:{}\s]*$/.test(data
        .replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, "@")
        .replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, "]")
        .replace(/(?:^|:|,)(?:\s*\[)+/g, ""))) {
      return window.JSON && window.JSON.parse ? window.JSON.parse(data) : data;
    } else {
      jQuery.error("Invalid JSON: " + data);
    }
  }
});

Drupal.behaviors.getpost = function () {
  'use strict';
  if (($.browser.msie && Drupal.settings.getpost.enable_ie) || (Drupal.settings.getpost.breakpoint)) {
    var searchData = function (element, data) {
      if (data.indexOf('ajaxSubmit') > 0) {
        var ajaxPost = true;
      }
    };
    $('form[method=get]').submit(function (e) {
      var ajaxPost = false, formAction = $(this).attr('action'), formdata = $(this).serialize();
      $(this).listHandlers('submit', searchData);
      if (!ajaxPost) {
        var urlLength = Drupal.settings.getpost.base_length + formdata.length;
        var ieEnabled = Drupal.settings.getpost.enable_ie;
        var maxLength = Drupal.settings.getpost.breakpoint;
        if ((ieEnabled && (urlLength > 2080)) ||
            (maxLength && (urlLength > maxLength))) {
          $.ajax({
            type: 'POST',
            url: '/getpost',
            data: $(this).serialize(),
            dataType: 'text',
            success: function (data) {
              var obj = $.parseJSON(data);
              window.location = formAction + '/?getpost=' + obj.key;
            }
          });
          e.preventDefault();
          return false;
        }
      }
    });
  }
};
